package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the rewritten syntactic unit:
  **
  ** assign-rest = [ var-rest ] := expression         */

public class AssignRest extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = ...;
    
    
    private Name  theName;  // name from NameStmt
    
    
    public AssignRest ( Scope c, Name n, TokenSet s ) {
        
        super(c,s);
        theName = n;
        
    }; // constructor
    
    
    public void parse ( ) {
        
        AVariable   dcl;           // variable declaration
        AType       type;          // variable type
        VarRest     aVarRest;      // the rest of a variable (subscript)
        Expression  anExpression;  // the expression
        String      lReg;          // register for lhs
        String      rReg;          // register for rhs
        
        dcl = asVarDcl(theName.getDecl());
        type = dcl.getType();
        lReg = varReference(theName.getQualifier(),dcl);
        check(...);
        if ( tokenIn(VarRest.STARTS) ) {
            aVarRest = new VarRest(scope,type,lReg,...);
            aVarRest.parse();
            type = aVarRest.getType();
        }
        expect(BECOMES,...);
        anExpression = new Expression(...);
        anExpression.parse();
            :
        rReg = anExpression.getReg();
        gen("sto",rReg,lReg);
        freeReg(rReg);
        freeReg(lReg);
        
    }; // parse
    
    
} // AssignRest