package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** method-body = { var-dcl ; } begin { statement } end    */

public class MethodBody extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = ...;
    
        :
    
    public void parse ( ) {
        
        VarDcl     aVarDcl;     // a variable dclaration
        Statement  aStatement;  // a statement
        AVariable  theVar;      // the variable being defined
        
        while ( true ) {
            check(oneOf(VarDcl.STARTS,BEGIN),...);
        if ( tokenIn(....except(VarDcl.STARTS,SEMI) ) break;
            if ( tokenIn(VarDcl.STARTS) ) {
                aVarDcl = new VarDcl(...);
                aVarDcl.parse();
                    :
            };
            expect(SEMI,...);
        };
        expect(BEGIN,...);
        gen("ntr",qualifiedLab(((AMethod)scope).getIdentifier()),
                  String.valueOf(((AMethod)scope).getLocalSize()));
        while ( true ) {
            check(oneOf(Statement.STARTS,END),...);
        if ( tokenIn(....except(Statement.STARTS) ) break;
            aStatement = new Statement(...);
            aStatement.parse();
        };
        expect(END,...);
        gen("rtn",String.valueOf(((AMethod)scope).getParamList().getSize()));
        
    }; // parse
    
    
} // MethodBody