package CompilerProj.Parser;

import CompilerProj.Lexical.*;
import CompilerProj.Semantic.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** term = factor { multiplying-op  factor }       */

public class Term extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = ...;
    
    
    private AType    result;  // result type
    private String   reg;     // register containing result
    
    
    public Term ( Scope c, TokenSet s ) {
        
        super(c,s);
        result = universalDcl;
        reg = "rx";
        
    }; // constructor
    
    
    public AType getType ( ) {
        
        return result;
        
    }; // getType
    
    
    public String getReg ( ) {
        
        return reg;
        
    }; // getReg
    
    
    public void parse ( ) {
        
        Factor         aFactor;   // a factor
        MultiplyingOp  aMulOp;    // a multiplying operator
        AType          leftOpnd;  // type of left operand
        TokenKind      op;        // operator
        String         rightReg;  // register containing right operand
        
        reg = null;
        op = TIMES;
        while ( true ) {
            aFactor = new Factor(...);
            aFactor.parse();
                :
            result = aFactor.getType();
                :
            if ( reg == null ) {  // first factor
                reg = aFactor.getReg();
            }
            else {                // already have a factor
                rightReg = aFactor.getReg();
                if ( op == TIMES ) {
                    if ( result.equals(typeInt) ) {
                        gen("mul",rightReg,reg);
                    }
                    else {
                        gen("mulf",rightReg,reg);
                    };
                }
                else {
                    if ( result.equals(typeInt) ) {
                        gen("div",rightReg,reg);
                    }
                    else {
                        gen("divf",rightReg,reg);
                    };
                };
                freeReg(rightReg);
            };
            check(...);
        if ( tokenIn(stopSet.except(MultiplyingOp.STARTS)) ) break;
                :
            if ( tokenIn(MultiplyingOp.STARTS) ) {
                aMulOp = new MultiplyingOp(...);
                aMulOp.parse();
                op = aMulOp.getOp();
            }
            else {
                op = TIMES;  // not a multiplying op use *
            };
        };
        
    }; // parse
    
    
} // Term